
;+----------------------------------------------------------+
;|  Program....: Lector de tarjetas de proximidad Indala    |
;|  Version....: Version 1.0a                               |
;|  Compiler...: Pemicro                                    |
;|  Author.....: Jorge M. Dhios                             |
;|  Date.......: 02/02/2003                                 |
;|  Last Update: 02/02/2003                                 |
;|  Purpose....:                                            |
;|                                                          |
;|  Copyright (c) 1994 Baires Robotics, All Right Reserved  |
*+----------------------------------------------------------+

RamStart EQU     $0080            ; Comienzo de la RAM para el JL3
RomStart EQU     $F600            ; Comienzo de la ROM/FLASH para el programa
VecStart EQU     $FFDE            ; Comienzo tabla de vectores varios

$Include 'jl3regs.inc'

         ORG     RamStart

buffcard:
start_0  RMB     2
start_ca RMB     1
cod_car  RMB     5
num_car  RMB     5
end_car  RMB     1
lrc_car  RMB     1
fin_0    RMB     2
END_C    EQU     *

COUNT    RMB     1

         ORG     RomStart

Start    RSP

MAIN     BRSET   CARDP,PORTB,$
         BSR     READC
         BRA     MAIN

*------------------------------------------

CARDP    EQU     7
CLOCK    EQU     6
DATOS    EQU     5

READC    SEI
         LDHX    #buffcard
NEXTBYTE MOV     #5,COUNT
HAYTARJ  BRCLR   CLOCK,PORTB,HAYDATO
         BRCLR   CARDP,PORTB,HAYTARJ
         CLI
         RTS

HAYDATO  BRSET   DATOS,PORTB,SETC
SETC     ROR     0,X

NOSUBE   BRCLR   CLOCK,PORTB,NOSUBE
         DBNZ    COUNT,HAYTARJ

         LSR     0,X
         LSR     0,X
         LSR     0,X
         LDA     0,X
         COMA
         AND     #%00001111
         ORA     #%00110000
         STA     0,X
         AIX     #1
         CPHX    #END_C
         BNE     NEXTBYTE

         CLI
         RTS
*------------------------------------------

         ORG    VecStart

         FDB    start              ; ADC Conversion Complete Vector
         FDB    start              ; Keyboard Vector
         FDB    0,0,0,0,0,0,0,0    ; (No Vectors Assigned $FFE2-$FFF1)
         FDB    start              ; TIM1 Overflow Vector
         FDB    start              ; TIM1 Channel 1 Vector
         FDB    start              ; TIM1 Channel 0 Vector
         FDB    start              ; (No Vector Assigned $FFF8-$FFF9)
         FDB    start              ; ~IRQ1
         FDB    start              ; SWI Vector
         FDB    start              ; Reset Vector
